from enum import Enum

class ErrorFieldCodeEnum(str, Enum):
    BAD_REQUEST = "BAD_REQUEST",
    UNAUTHORIZED = "UNAUTHORIZED",
    FORBIDDEN = "FORBIDDEN",
    NOT_FOUND = "NOT_FOUND",
    CONFLICT = "CONFLICT",
    CONTENT_TOO_LARGE = "CONTENT_TOO_LARGE",
    INTERNAL_SERVER_ERROR = "INTERNAL_SERVER_ERROR",
    GATEWAY_TIMEOUT = "GATEWAY_TIMEOUT",
    DOCUMENTTYPE_NOT_FOUND = "DOCUMENTTYPE_NOT_FOUND",
    DOCUMENTTYPE_NAME_EXISTS = "DOCUMENTTYPE_NAME_EXISTS",
    DOCUMENTTYPE_NOT_EDITABLE = "DOCUMENTTYPE_NOT_EDITABLE",
    COMPARE_DOC_IS_EMPTY = "COMPARE_DOC_IS_EMPTY",
    COMPARE_WRONG_LANGUAGE = "COMPARE_WRONG_LANGUAGE",
    COMPARE_NO_REFERENCES = "COMPARE_NO_REFERENCES",
    DOMAIN_NOT_FOUND = "DOMAIN_NOT_FOUND",
    TOO_MANY_TOKENS = "TOO_MANY_TOKENS",
    NO_FILE_FOUND = "NO_FILE_FOUND",
    FILE_TYPE_NOT_SUPPORTED = "FILE_TYPE_NOT_SUPPORTED",
    FILE_PASSWORDPROTECTED = "FILE_PASSWORDPROTECTED",
    MISSING_SERVICE_DEFINITION = "MISSING_SERVICE_DEFINITION",
    SERVICE_CALL_ERROR = "SERVICE_CALL_ERROR",
    GENERATIVE_MODEL_ERROR = "GENERATIVE_MODEL_ERROR",
    USED_AS_LINKED_EXTRACTOR = "USED_AS_LINKED_EXTRACTOR",
    CYCLICAL_DEPENDENCY_LINKED_EXTRACTOR = "CYCLICAL_DEPENDENCY_LINKED_EXTRACTOR",
    FILE_TOO_BIG = "FILE_TOO_BIG",
    TOO_MANY_ROWS = "TOO_MANY_ROWS",
    REGEX_INVALID = "REGEX_INVALID",
    GENERATIVE_MODEL_CONTEXT_EXCEEDED = "GENERATIVE_MODEL_CONTEXT_EXCEEDED",
    PROMPT_NOT_DELETABLE = "PROMPT_NOT_DELETABLE",
    RESOURCE_NOT_FOUND = "RESOURCE_NOT_FOUND",
    PARENT_RESOURCE_NOT_FOUND = "PARENT_RESOURCE_NOT_FOUND",
    RESOURCE_PARAMETER_CONSTRAINT_VIOLATION = "RESOURCE_PARAMETER_CONSTRAINT_VIOLATION",
    PLATFORM_UNREACHABLE = "PLATFORM_UNREACHABLE",
    FILE_SIZE_TOOBIG = "FILE_SIZE_TOOBIG",
    USER_REPOSITORY_NOT_CONFIGURED = "USER_REPOSITORY_NOT_CONFIGURED",
    PDF_NOT_CONFIGURED = "PDF_NOT_CONFIGURED",
    INVALID_USER_PASSWORD = "INVALID_USER_PASSWORD",
    UNKNOWN_FINGERPRINTER_ID = "UNKNOWN_FINGERPRINTER_ID",
    JSON_ARRAY_EMPTY = "JSON_ARRAY_EMPTY",
    TOKENS_ILLEGAL_TYPE = "TOKENS_ILLEGAL_TYPE",
    NO_JSON = "NO_JSON",
    INVALID_JSON_FORMAT = "INVALID_JSON_FORMAT",
    JSON_OBJECT_HAS_NO_DOCUMENTS = "JSON_OBJECT_HAS_NO_DOCUMENTS",
    DOCUMENTS_ARE_NO_JSON_ARRAY = "DOCUMENTS_ARE_NO_JSON_ARRAY",
    DOCUMENTS_JSON_ARRAY_EMPTY = "DOCUMENTS_JSON_ARRAY_EMPTY",
    DOCUMENTS_VALUE_ERROR = "DOCUMENTS_VALUE_ERROR",
    DOCUMENTS_TYPE_ERROR = "DOCUMENTS_TYPE_ERROR",
    DOCUMENTS_TOO_FEW_DOCUMENTS = "DOCUMENTS_TOO_FEW_DOCUMENTS",
    REQ_NO_JSON_ARRAY = "REQ_NO_JSON_ARRAY",
    SENTENCE_LIST_NOT_TWO = "SENTENCE_LIST_NOT_TWO",
    IMAGE_NOT_PROVIDED = "IMAGE_NOT_PROVIDED",
    IMAGE_INVALID_FORMAT = "IMAGE_INVALID_FORMAT",
    MODEL_NAME_INVALID = "MODEL_NAME_INVALID",
    THRESHOLD_INVALID = "THRESHOLD_INVALID",
    IMAGE_BUFFER_EMPTY = "IMAGE_BUFFER_EMPTY",
    INVALID_MODEL_ID = "INVALID_MODEL_ID",
    IMAGE_NOT_PROVIDED_IFP = "IMAGE_NOT_PROVIDED_IFP",
    IMAGE_INVALID_DATA = "IMAGE_INVALID_DATA",
    IMAGE_INVALID_FORMAT_IFP = "IMAGE_INVALID_FORMAT_IFP",
    
    def __str__(self) -> str:
        return self.value
